Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/core/DefaultReceptionist.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/core/DefaultReceptionist.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/core/DefaultReceptionist.java	(revision 24007)
@@ -17,145 +17,152 @@
 
 /** The default greenstone receptionist - needs some extra info for each page
- */
+*/
 public class DefaultReceptionist extends TransformingReceptionist {
 
-     static Logger logger = Logger.getLogger(org.greenstone.gsdl3.core.DefaultReceptionist.class.getName());
-    
-  /** add in the collection description to the page, then for each service, add in the service description */
-    protected void addExtraInfo(Element page) {
-      super.addExtraInfo(page);
+	static Logger logger = Logger.getLogger(org.greenstone.gsdl3.core.DefaultReceptionist.class.getName());
 	
-	Element page_request = (Element)GSXML.getChildByTagName(page, GSXML.PAGE_REQUEST_ELEM);
-	// if it is a system request, then we don't bother with this.
-	String action = page_request.getAttribute(GSXML.ACTION_ATT);
-	if (action.equals("s")) {
-	    logger.error("HACK: don't ask for coll info if system action");
-	    return;
+	/** add in the collection description to the page, then for each service, add in the service description */
+	protected void addExtraInfo(Element page) {
+		super.addExtraInfo(page);
+		
+		Element page_request = (Element)GSXML.getChildByTagName(page, GSXML.PAGE_REQUEST_ELEM);
+		// if it is a system request, then we don't bother with this.
+		String action = page_request.getAttribute(GSXML.ACTION_ATT);
+		if (action.equals("s")) {
+			logger.error("HACK: don't ask for coll info if system action");
+			return;
+		}
+		logger.debug("add extra info, page request="+this.converter.getString(page_request));
+		// is a collection defined?
+		Element param_list = (Element)GSXML.getChildByTagName(page_request, GSXML.PARAM_ELEM+GSXML.LIST_MODIFIER);
+		if (param_list==null) { // must be the original home page
+			logger.debug(" no param list, assuming home page");
+			return;
+		}
+		Element coll_param = GSXML.getNamedElement(param_list, GSXML.PARAM_ELEM, GSXML.NAME_ATT, GSParams.COLLECTION);
+		if (coll_param == null) {
+			logger.debug(" coll param is null, returning");
+			return;
+		}
+
+		// see if the collection/cluster element is already there
+		String coll_name = coll_param.getAttribute(GSXML.VALUE_ATT);
+		String lang = page_request.getAttribute(GSXML.LANG_ATT);
+		String uid = page_request.getAttribute(GSXML.USER_ID_ATT);
+		
+		if (coll_name.equals("")) {
+			Element pc_param = GSXML.getNamedElement(param_list, GSXML.PARAM_ELEM, GSXML.NAME_ATT, "p.c");
+			if(pc_param != null)
+			{
+				coll_name = pc_param.getAttribute(GSXML.VALUE_ATT);
+			}
+		}
+		
+		boolean get_service_description = false;
+		Element page_response = (Element)GSXML.getChildByTagName(page, GSXML.PAGE_RESPONSE_ELEM);
+		if (this.language_list != null) {
+			page_response.appendChild(this.language_list);
+		}
+		Element coll_description = (Element)GSXML.getChildByTagName(page_response, GSXML.COLLECTION_ELEM);
+		if (coll_description == null) {
+			// try cluster
+			coll_description = (Element)GSXML.getChildByTagName(page_response, GSXML.CLUSTER_ELEM);
+		}
+		if (coll_description == null) { 
+		
+			// we dont have one yet - get it
+			Element coll_about_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
+			Element coll_about_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE,  coll_name, lang, uid);
+			coll_about_message.appendChild(coll_about_request);
+			
+			Node coll_about_response_message = this.mr.process(coll_about_message);
+			Element coll_about_response = (Element)GSXML.getChildByTagName(coll_about_response_message, GSXML.RESPONSE_ELEM);
+			if (coll_about_response == null) {
+				return;
+			}
+			coll_description = (Element)GSXML.getChildByTagName(coll_about_response, GSXML.COLLECTION_ELEM);
+			if (coll_description==null) { // may be a cluster
+				coll_description = (Element)GSXML.getChildByTagName(coll_about_response, GSXML.CLUSTER_ELEM);
+			}
+			
+			if (coll_description == null) {
+				logger.error(" no collection description, returning");
+				return;
+			}
+			// have found one, append it to the page response
+			coll_description = (Element)this.doc.importNode(coll_description, true);
+			page_response.appendChild(coll_description);
+			get_service_description = true;
+		}
+
+		// have got a coll description
+		// now get the dispay info for the services
+		Element service_list = (Element)GSXML.getChildByTagName(coll_description, GSXML.SERVICE_ELEM+GSXML.LIST_MODIFIER);
+		if (service_list == null) {
+			logger.error(" no service list, returning");
+			// something weird has gone wrong
+			return;
+		}
+
+		NodeList services = service_list.getElementsByTagName(GSXML.SERVICE_ELEM);
+		if (services.getLength()==0) {
+			logger.error("DefaultReceoptionist: no services found for colllection/cluster "+ coll_name);
+			return;
+		}
+		// check one service for display items
+		if (!get_service_description) {
+			// we dont know yet if we need to get these
+			int i=1;
+			Element test_s = (Element)services.item(0);
+			while (i<services.getLength() && (test_s.getAttribute(GSXML.TYPE_ATT).equals(GSXML.SERVICE_TYPE_RETRIEVE) || test_s.getAttribute(GSXML.TYPE_ATT).equals(GSXML.SERVICE_TYPE_OAI))) {
+				test_s = (Element)services.item(i); i++;
+			}
+			if (i==services.getLength()) {
+				// we have only found retrieve or oai services, so dont need descripitons anyway
+				return;
+			}
+			if (GSXML.getChildByTagName(test_s, GSXML.DISPLAY_TEXT_ELEM) !=null) {
+				// have got descriptions already, 
+				return;
+			}
+		}
+
+		// if get here, we need to get the service descriptions
+		
+		// we will send all the requests in a single message
+		Element info_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
+		for (int i=0; i<services.getLength(); i++) {
+			Element c = (Element)services.item(i);
+			String name = c.getAttribute(GSXML.NAME_ATT);
+			String address = GSPath.appendLink(coll_name, name);
+			Element info_request = GSXML.createBasicRequest(this.doc,  GSXML.REQUEST_TYPE_DESCRIBE, address, lang, uid);
+			//Element req_param_list = this.doc.createElement(GSXML.PARAM_ELEM+GSXML.LIST_MODIFIER);
+			//req_param_list.appendChild(GSXML.createParameter(this.doc, GSXML.SUBSET_PARAM, GSXML.DISPLAY_TEXT_ELEM+GSXML.LIST_MODIFIER));
+			//info_request.appendChild(req_param_list);
+			info_message.appendChild(info_request);
+			
+		}
+
+		Element info_response = (Element)this.mr.process(info_message);
+
+		NodeList service_responses = info_response.getElementsByTagName(GSXML.RESPONSE_ELEM);
+		// check that have same number of responses as collections
+		if (services.getLength() != service_responses.getLength()) {
+			logger.error(" didn't get a response for each service - somethings gone wrong!");
+			// for now, dont use the metadata
+		} else {
+			for (int i=0; i<services.getLength(); i++) {
+				Element c1 = (Element)services.item(i);
+				Element c2 = (Element)GSXML.getChildByTagName((Element)service_responses.item(i), GSXML.SERVICE_ELEM);
+				if (c1 !=null && c2 !=null && c1.getAttribute(GSXML.NAME_ATT).equals(c2.getAttribute(GSXML.NAME_ATT))) {
+					//add the service data into the original response
+					GSXML.mergeElements(c1, c2);
+				} else {
+					logger.debug(" response does not correspond to request!");
+				} 
+				
+			}
+		}
 	}
-	logger.debug("add extra info, page request="+this.converter.getString(page_request));
-	// is a collection defined?
-	Element param_list = (Element)GSXML.getChildByTagName(page_request, GSXML.PARAM_ELEM+GSXML.LIST_MODIFIER);
-	if (param_list==null) { // must be the original home page
-	    logger.debug(" no param list, assuming home page");
-	    return;
-	}
-	Element coll_param = GSXML.getNamedElement(param_list, GSXML.PARAM_ELEM, GSXML.NAME_ATT, GSParams.COLLECTION);
-	if (coll_param == null) {
-	    logger.debug(" coll param is null, returning");
-	    return;
-	}
-
-	// see if the collection/cluster element is already there
-	String coll_name = coll_param.getAttribute(GSXML.VALUE_ATT);
-	String lang = page_request.getAttribute(GSXML.LANG_ATT);
-	String uid = page_request.getAttribute(GSXML.USER_ID_ATT);
-	
-	boolean get_service_description = false;
-	Element page_response = (Element)GSXML.getChildByTagName(page, GSXML.PAGE_RESPONSE_ELEM);
-	if (this.language_list != null) {
-	    page_response.appendChild(this.language_list);
-	}
-	Element coll_description = (Element)GSXML.getChildByTagName(page_response, GSXML.COLLECTION_ELEM);
-	if (coll_description == null) {
-	    // try cluster
-	    coll_description = (Element)GSXML.getChildByTagName(page_response, GSXML.CLUSTER_ELEM);
-	}
-	if (coll_description == null) { 
-	    // we dont have one yet - get it
-	    Element coll_about_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-	    Element coll_about_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE,  coll_name, lang, uid);
-	    coll_about_message.appendChild(coll_about_request);
-	    
-	    Node coll_about_response_message = this.mr.process(coll_about_message);
-	    Element coll_about_response = (Element)GSXML.getChildByTagName(coll_about_response_message, GSXML.RESPONSE_ELEM);
-	    if (coll_about_response == null) {
-		return;
-	    }
-	    coll_description = (Element)GSXML.getChildByTagName(coll_about_response, GSXML.COLLECTION_ELEM);
-	    if (coll_description==null) { // may be a cluster
-		coll_description = (Element)GSXML.getChildByTagName(coll_about_response, GSXML.CLUSTER_ELEM);
-	    }
-	    
-	    if (coll_description == null) {
-		logger.error(" no collection description, returning");
-		return;
-	    }
-	    // have found one, append it to the page response
-	    coll_description = (Element)this.doc.importNode(coll_description, true);
-	    page_response.appendChild(coll_description);
-	    get_service_description = true;
-	}
-
-	// have got a coll description
-	
-	// now get the dispay info for the services
-	Element service_list = (Element)GSXML.getChildByTagName(coll_description, GSXML.SERVICE_ELEM+GSXML.LIST_MODIFIER);
-	if (service_list == null) {
-	    logger.error(" no service list, returning");
-	    // something weird has gone wrong
-	    return;
-	}
-
-	NodeList services = service_list.getElementsByTagName(GSXML.SERVICE_ELEM);
-	if (services.getLength()==0) {
-	    logger.error("DefaultReceoptionist: no services found for colllection/cluster "+ coll_name);
-	    return;
-	}
-	// check one service for display items
-	if (!get_service_description) {
-	    // we dont know yet if we need to get these
-	    int i=1;
-	    Element test_s = (Element)services.item(0);
-	    while (i<services.getLength() && (test_s.getAttribute(GSXML.TYPE_ATT).equals(GSXML.SERVICE_TYPE_RETRIEVE) || test_s.getAttribute(GSXML.TYPE_ATT).equals(GSXML.SERVICE_TYPE_OAI))) {
-		test_s = (Element)services.item(i); i++;
-	    }
-	    if (i==services.getLength()) {
-		// we have only found retrieve or oai services, so dont need descripitons anyway
-		return;
-	    }
-	    if (GSXML.getChildByTagName(test_s, GSXML.DISPLAY_TEXT_ELEM) !=null) {
-		// have got descriptions already, 
-		return;
-	    }
-	}
-
-	// if get here, we need to get the service descriptions
-	    
-	// we will send all the requests in a single message
-	Element info_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-	for (int i=0; i<services.getLength(); i++) {
-	    Element c = (Element)services.item(i);
-	    String name = c.getAttribute(GSXML.NAME_ATT);
-	    String address = GSPath.appendLink(coll_name, name);
-	    Element info_request = GSXML.createBasicRequest(this.doc,  GSXML.REQUEST_TYPE_DESCRIBE, address, lang, uid);
-	    Element req_param_list = this.doc.createElement(GSXML.PARAM_ELEM+GSXML.LIST_MODIFIER);
-	    req_param_list.appendChild(GSXML.createParameter(this.doc, GSXML.SUBSET_PARAM, GSXML.DISPLAY_TEXT_ELEM+GSXML.LIST_MODIFIER));
-	    info_request.appendChild(req_param_list);
-	    info_message.appendChild(info_request);
-	    
-	}
-
-	Element info_response = (Element)this.mr.process(info_message);
-
-	NodeList service_responses = info_response.getElementsByTagName(GSXML.RESPONSE_ELEM);
-	// check that have same number of responses as collections
-	if (services.getLength() != service_responses.getLength()) {
-	    logger.error(" didn't get a response for each service - somethings gone wrong!");
-	    // for now, dont use the metadata
-	} else {
-	    for (int i=0; i<services.getLength(); i++) {
-		Element c1 = (Element)services.item(i);
-		Element c2 = (Element)GSXML.getChildByTagName((Element)service_responses.item(i), GSXML.SERVICE_ELEM);
-		if (c1 !=null && c2 !=null && c1.getAttribute(GSXML.NAME_ATT).equals(c2.getAttribute(GSXML.NAME_ATT))) {
-		    //add the service data into the original response
-		    GSXML.mergeElements(c1, c2);
-		} else {
-		    logger.debug(" response does not correspond to request!");
-		} 
-		
-	    }
-	}
-	
-    }
 }
 
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java	(revision 24007)
@@ -44,4 +44,6 @@
 
 import org.apache.log4j.*;
+
+import org.apache.commons.lang3.StringUtils;
 
 /**
@@ -271,5 +273,5 @@
         // be passed to multiple modules  - they will be in a comma 
         // separated list in the 'to' attribute
-        String [] modules = path.split(",");
+        String [] modules = StringUtils.split(path, ",");
         
         for (int j=0; j<modules.length; j++) {
@@ -619,6 +621,8 @@
           //The collection name is returned as site_name:coll_name, which is in fact the set specification
           ane.setAttribute(GSXML.NAME_ATT, site_name + ":" + col_name);
-          ane.setAttribute(OAIXML.LASTMODIFIED, "" + c.getLastmodified());
-          
+          ane.setAttribute(OAIXML.LASTMODIFIED, "" + c.getLastmodified()); 
+	       // lastmodified not of use anymore for OAI, perhaps useful as general information
+	  ane.setAttribute(OAIXML.EARLIEST_DATESTAMP, "" + c.getEarliestDatestamp()); // for OAI
+
           this.oai_collection_list.appendChild(ane);
           //logger.info(GSXML.xmlNodeToString(oai_collection_list));
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/core/OAIReceptionist.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/core/OAIReceptionist.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/core/OAIReceptionist.java	(revision 24007)
@@ -296,5 +296,5 @@
        *  Use the time value plus the current system time to get the expiration date string.
        */
-      String expiration_date = OAIXML.getTime(System.currentTimeMillis() + OAIXML.getTokenExpiration());
+	String expiration_date = OAIXML.getTime(System.currentTimeMillis() + OAIXML.getTokenExpiration()); // in milliseconds
       token.setAttribute(OAIXML.EXPIRATION_DATE, expiration_date);
     }
@@ -339,9 +339,32 @@
     
     HashMap param_map = OAIXML.getParamMap(params);    
-    if (!isValidParam(param_map, valid_strs) ||
-        !param_map.containsKey(OAIXML.METADATA_PREFIX)) {
-      logger.error("contains invalid params or no metadataPrefix");
-      return getMessage(OAIXML.createErrorElement(OAIXML.BAD_ARGUMENT, ""));
+    if (!isValidParam(param_map, valid_strs)) {
+	logger.error("One of the params is invalid");
+	return getMessage(OAIXML.createErrorElement(OAIXML.BAD_ARGUMENT, ""));
     } 
+    // param keys are valid, but if there are any date params, check they're of the right format
+    String from = (String)param_map.get(OAIXML.FROM);
+    if(from != null) {	
+	Date from_date = OAIXML.getDate(from);
+	if(from_date == null) {
+	    logger.error("invalid date: " + from);
+	    return getMessage(OAIXML.createErrorElement(OAIXML.BAD_ARGUMENT, ""));
+	}
+    }
+    String until = (String)param_map.get(OAIXML.UNTIL);
+    if(until != null) {	
+	Date until_date = OAIXML.getDate(until);
+	if(until_date == null) {
+	    logger.error("invalid date: " + until);
+	    return getMessage(OAIXML.createErrorElement(OAIXML.BAD_ARGUMENT, ""));
+	} 
+    }    
+    if(from != null && until != null) { // check they are of the same date-time format (granularity)
+	if(from.length() != until.length()) {
+	    logger.error("The request has different granularities (date-time formats) for the From and Until date parameters.");
+	    return getMessage(OAIXML.createErrorElement(OAIXML.BAD_ARGUMENT, ""));
+	}
+    }
+
     //ask the message router for a list of oai collections
     NodeList oai_coll = getOAICollectionList();
@@ -350,10 +373,4 @@
       logger.info("returned oai collection list is empty");
       return getMessage(OAIXML.createErrorElement(OAIXML.NO_RECORDS_MATCH, ""));
-    }
-    //Now that we got a prefix, check and see if it's supported by this repository
-    String prefix_value = (String)param_map.get(OAIXML.METADATA_PREFIX);
-    if (containsMetadataPrefix(prefix_value) == false) {
-      logger.error("requested prefix is not found in OAIConfig.xml");
-      return getMessage(OAIXML.createErrorElement(OAIXML.CANNOT_DISSEMINATE_FORMAT, ""));
     }
     
@@ -390,4 +407,18 @@
     }
     
+    // Custom test that expects a metadataPrefix comes here at end so that the official params can
+    // be tested first for errors and their error responses sent off. Required for OAI validation
+    if (!param_map.containsKey(OAIXML.METADATA_PREFIX)) {
+      logger.error("contains invalid params or no metadataPrefix");
+      return getMessage(OAIXML.createErrorElement(OAIXML.BAD_ARGUMENT, ""));
+    }    
+    
+    //Now that we got a prefix, check and see if it's supported by this repository
+    String prefix_value = (String)param_map.get(OAIXML.METADATA_PREFIX);
+    if (containsMetadataPrefix(prefix_value) == false) {
+      logger.error("requested prefix is not found in OAIConfig.xml");
+      return getMessage(OAIXML.createErrorElement(OAIXML.CANNOT_DISSEMINATE_FORMAT, ""));
+    }
+
     //Now that all validation has been done, I hope, we can send request to the message router
     Element result = null;
@@ -519,14 +550,32 @@
     
     HashMap param_map = OAIXML.getParamMap(params);    
-    if (!isValidParam(param_map, valid_strs) ||
-        !param_map.containsKey(OAIXML.METADATA_PREFIX)) {
-      // it must have a metadataPrefix
-      /** Here I disagree with the OAI specification: even if a resumptionToken is 
-       *  included in the request, the metadataPrefix is a must argument. Otherwise
-       *  how would we know what metadataPrefix the harvester requested in his last request?
-       */
-      logger.error("no metadataPrefix");
-      return getMessage(OAIXML.createErrorElement(OAIXML.BAD_ARGUMENT, ""));
-    } 
+    if (!isValidParam(param_map, valid_strs)) {
+	logger.error("One of the params is invalid");
+	return getMessage(OAIXML.createErrorElement(OAIXML.BAD_ARGUMENT, ""));
+    }
+    // param keys are valid, but if there are any date params, check they're of the right format
+    String from = (String)param_map.get(OAIXML.FROM);
+    if(from != null) {	
+	Date from_date = OAIXML.getDate(from);
+	if(from_date == null) {
+	    logger.error("invalid date: " + from);
+	    return getMessage(OAIXML.createErrorElement(OAIXML.BAD_ARGUMENT, ""));
+	}
+    }
+    String until = (String)param_map.get(OAIXML.UNTIL);
+    Date until_date = null;
+    if(until != null) {	
+	until_date = OAIXML.getDate(until);
+	if(until_date == null) {
+	    logger.error("invalid date: " + until);
+	    return getMessage(OAIXML.createErrorElement(OAIXML.BAD_ARGUMENT, ""));
+	} 
+    }
+    if(from != null && until != null) { // check they are of the same date-time format (granularity)
+	if(from.length() != until.length()) {
+	    logger.error("The request has different granularities (date-time formats) for the From and Until date parameters.");
+	    return getMessage(OAIXML.createErrorElement(OAIXML.BAD_ARGUMENT, ""));
+	}
+    }
     
     //ask the message router for a list of oai collections
@@ -536,11 +585,4 @@
       logger.info("returned oai collection list is empty");
       return getMessage(OAIXML.createErrorElement(OAIXML.NO_RECORDS_MATCH, ""));
-    }
-    
-    //Now that we got a prefix, check and see if it's supported by this repository
-    String prefix_value = (String)param_map.get(OAIXML.METADATA_PREFIX);
-    if (containsMetadataPrefix(prefix_value) == false) {
-      logger.error("requested prefix is not found in OAIConfig.xml");
-      return getMessage(OAIXML.createErrorElement(OAIXML.CANNOT_DISSEMINATE_FORMAT, ""));
     }
     
@@ -585,4 +627,25 @@
       }
     }
+
+    // Moved the additional custom test that mandates the metadataPrefix here, since official
+    // errors should be caught first, so that their error responses can be sent off first
+    // such that GS2's oaiserver will validate properly.
+    if (!param_map.containsKey(OAIXML.METADATA_PREFIX)) {
+      // it must have a metadataPrefix
+      /** Here I disagree with the OAI specification: even if a resumptionToken is 
+       *  included in the request, the metadataPrefix is a must argument. Otherwise
+       *  how would we know what metadataPrefix the harvester requested in his last request?
+       */
+      logger.error("no metadataPrefix");
+      return getMessage(OAIXML.createErrorElement(OAIXML.BAD_ARGUMENT, ""));
+    }
+        
+    //Now that we got a prefix, check and see if it's supported by this repository
+    String prefix_value = (String)param_map.get(OAIXML.METADATA_PREFIX);
+    if (containsMetadataPrefix(prefix_value) == false) {
+      logger.error("requested prefix is not found in OAIConfig.xml");
+      return getMessage(OAIXML.createErrorElement(OAIXML.CANNOT_DISSEMINATE_FORMAT, ""));
+    }
+
     //Now that all validation has been done, I hope, we can send request to the message router
     Element result = null;
@@ -704,4 +767,7 @@
     }
     Element res_in_result = (Element)GSXML.getChildByTagName(result, OAIXML.RESPONSE);
+    if(res_in_result == null) { // return the results of all other collections accumulated so far
+	return msg;
+    }
     Element verb_elem = (Element)GSXML.getChildByTagName(res_in_result, verb);
     if(msg == null) {
@@ -787,4 +853,8 @@
         // get the names
         strs = splitNames(identifier);
+	if(strs == null || strs.length < 3) {
+	    logger.error("identifier is not in the form site:coll:id" + identifier);
+	    return getMessage(OAIXML.createErrorElement(OAIXML.ID_DOES_NOT_EXIST, ""));
+	}
         String name_of_site = strs[0];
         String coll_name = strs[1];
@@ -831,9 +901,5 @@
     //do the protocol version
     copyElement(identify, OAIXML.PROTOCOL_VERSION);
-    //do the deletedRecord
-    copyElement(identify, OAIXML.DELETED_RECORD);
-    //do the granularity
-    copyElement(identify, OAIXML.GRANULARITY);
-    
+        
     //There can be more than one admin email according to the OAI specification
     NodeList admin_emails = GSXML.getChildrenByTagName(oai_config, OAIXML.ADMIN_EMAIL);
@@ -848,22 +914,17 @@
 
     //do the earliestDatestamp
-    long lastmodified = System.currentTimeMillis();
     //send request to mr to search through the earliest datestamp amongst all oai collections in the repository.
     //ask the message router for a list of oai collections
     NodeList oai_coll = getOAICollectionList();
-    int oai_coll_size = oai_coll.getLength();
-    if (oai_coll_size == 0) {
-      logger.info("returned oai collection list is empty. Set repository earliestDatestamp to be 1970-01-01.");
-      lastmodified = 0;
-    }
-    //the collection build time is determined by the last modified time of the buildConfig.xml file
-    for(int i=0; i<oai_coll_size; i++) {
-      long coll_build_time = Long.parseLong(((Element)oai_coll.item(i)).getAttribute(OAIXML.LASTMODIFIED));
-      lastmodified = (lastmodified > coll_build_time)? coll_build_time : lastmodified;
-    }
-    String earliestDatestamp_str = OAIXML.getTime(lastmodified);
+    long earliestDatestamp = getEarliestDateStamp(oai_coll);
+    String earliestDatestamp_str = OAIXML.getTime(earliestDatestamp);
     Element earliestDatestamp_elem = OAIXML.createElement(OAIXML.EARLIEST_DATESTAMP);
     GSXML.setNodeText(earliestDatestamp_elem, earliestDatestamp_str);
     identify.appendChild(earliestDatestamp_elem);
+
+    //do the deletedRecord
+    copyElement(identify, OAIXML.DELETED_RECORD);
+    //do the granularity
+    copyElement(identify, OAIXML.GRANULARITY);
         
     return getMessage(identify);
@@ -886,4 +947,7 @@
     String [] strs = new String[3];
     int first_colon = identifier.indexOf(":");
+    if(first_colon == -1) {
+	return null;
+    }
     strs[0] = identifier.substring(0, first_colon);
 
@@ -968,3 +1032,24 @@
     return converter.nodeToElement(result_node);
   }
+
+    // See OAIConfig.xml
+    // dynamically works out what the earliestDateStamp is, since it varies by collection
+    // returns this time in *milliseconds*.
+    protected long getEarliestDateStamp(NodeList oai_coll) {
+	//do the earliestDatestamp
+	long earliestDatestamp = System.currentTimeMillis();	
+	int oai_coll_size = oai_coll.getLength();
+	if (oai_coll_size == 0) {
+	    logger.info("returned oai collection list is empty. Setting repository earliestDatestamp to be 1970-01-01.");
+	    earliestDatestamp = 0;
+	}
+	// the earliestDatestamp is now stored as a metadata element in the collection's buildConfig.xml file
+	// we get the earliestDatestamp among the collections
+	for(int i=0; i<oai_coll_size; i++) {
+	    long coll_earliestDatestamp = Long.parseLong(((Element)oai_coll.item(i)).getAttribute(OAIXML.EARLIEST_DATESTAMP));
+	    earliestDatestamp = (earliestDatestamp > coll_earliestDatestamp)? coll_earliestDatestamp : earliestDatestamp;
+	}
+
+	return earliestDatestamp*1000; // converting from seconds to milliseconds
+    }
 }
